import pygst
pygst.require("0.10")
import gst
import pygtk
import gtk, gobject
import signal, os
import time
import dbus
import audioop
from struct import *
import config 		#This has all the golabals


class AudioGrab(gobject.GObject):
	__gsignals__ = {
		'new-buffer': (gobject.SIGNAL_RUN_FIRST, None, [gobject.TYPE_PYOBJECT, gobject.TYPE_BOOLEAN, gobject.TYPE_PYOBJECT])
	}

	def __init__(self, datastore, _jobject):

		gobject.GObject.__init__(self)
		
		self.temp_buffer = []
		self.snapshot_buffer = []
		
		self.draw_graph_status = False
		self.f = None
        	self.logging_status = False
		self.wave_copy = None
		self.electrical_ui_copy = None

		self.rate = 48000		
		self.final_count = 0
		self.count_temp = 0
		self.entry_count = 0
	
		self.datastore = datastore
		self._jobject = _jobject
		
		self.pipeline = gst.Pipeline("pipeline")

		alsasrc = gst.element_factory_make("alsasrc", "alsa-source")
		self.pipeline.add(alsasrc)
		
		self.caps1 = gst.element_factory_make("capsfilter", "caps1")
		self.pipeline.add(self.caps1)

		caps_str = "audio/x-raw-int,rate=%d,channels=1,depth=16" % (self.rate, )
		self.caps1.set_property("caps", gst.caps_from_string(\
			caps_str) )

		self.fakesink = gst.element_factory_make("fakesink", "fsink")
		self.pipeline.add(self.fakesink)		
		self.fakesink.connect("handoff", self.on_buffer)	
		
		gst.element_link_many(alsasrc, self.caps1, self.fakesink)


		
		

	def on_quit(self):
		self.fakesink.set_property("signal-handoffs", False)		
		self.pipeline.set_state(gst.STATE_NULL)
		################Alsamixer settings at Activity close########
		#This is a well mannered activity. It takes care to 
		#set default settings back.
		#Although these are also handled by the Kernel.		
		os.system("amixer set 'Mic Boost (+20dB)' mute")		
		os.system("amixer set 'DC Mode Enable' mute")
		os.system("amixer set 'V_REFOUT Enable' mute")
		os.system("amixer set 'Master' unmute 70%")
		os.system("amixer set 'Master Mono' unmute 70%")
		os.system("amixer set 'Capture' 50%, 100% unmute captur")
		############################################################

		

	def _new_buffer(self, buf):
		# on the main thread
		if(self.logging_status == True):
			if(self.final_count == 388850):	#388850 is a special value for indicating 'Snapshot'
				for val in self.snapshot_buffer:				
					self.f.write(str(val)+'\n')	#Write the latest buffer
				self.f.write("stop")				
				self.f.close()
				self.datastore.write(self._jobject)
				self.logging_status = False
			else:
				if(self.entry_count <= 1000):
					self.count_temp+=1
					if(self.count_temp == self.final_count):
						self.count_temp = 0
						write_buffer = unpack( str(int(len(buf))/2)+'h' , buf)
						self.f.write(str(write_buffer[int(len(buf)/4.0)])+'\n')	#Writing the middle value of the buffer available at each logging time
						self.entry_count+=1
								
		self.emit("new-buffer", buf, self.draw_graph_status, self.f)
		return False


	# Could be in a different thread
	def on_buffer(self, element, buffer, pad):		
		gobject.timeout_add(30, self._new_buffer, str(buffer))		
		return True

	def set_logging_status(self, status, f, multiplier):
		self.logging_status = status
		if(status == True):
			self.f = f
			self.final_count = (multiplier*50)
			self.count_temp = 0
			self.entry_count = 0		
		if(status == False):
			self.f.write("stop")			
			self.f.close()
			self.datastore.write(self._jobject)
			self.logging_status = False
	
	def start_drawing_graph(self, status, f):
		self.draw_graph_status = status
		if(self.draw_graph_status == True):		
			self.f = f

	def snapshot(self):
		self.snapshot_buffer = self.wave_copy.buffers

	def set_wave_copy(self, wave):
		self.wave_copy = wave		

	def set_reference_electrical(self,electrical_ui):
		self.electrical_ui_copy = electrical_ui

	def stop_sound_device(self):
		self.pipeline.set_state(gst.STATE_NULL)

	def restart_sound_device(self):
		self.pipeline.set_state(gst.STATE_PLAYING)
		# If V_REFOUT and DC Mode Enable were at non-default 
		# settings when Activity 
		# went into background,
		# we need to set them back.
		if(self.electrical_ui_copy.acdc_status == 'dc'):
			os.system("amixer set 'DC Mode Enable' unmute")
			os.system("amixer set 'Capture' 0%, 0% unmute captur")
			os.system("amixer set 'Mic Boost (+20dB)' mute")		
		if(self.electrical_ui_copy.bias_status == 'biasoff'):
			os.system("amixer set 'V_REFOUT Enable' mute")


	#sets sampling rate for low, med and high frequency modes
	#depending upon value of level being 'l' 'm' or 'h'
	def set_sampling_rate(self, level):
		self.stop_sound_device()
		if(level=='l'):
			self.rate = 4000
		elif(level=='m'):
			self.rate = 16000
		elif(level=='h'):
			self.rate = 48000
		caps_str = "audio/x-raw-int,rate=%d,channels=1,depth=16" % (self.rate, )
		self.caps1.set_property("caps", gst.caps_from_string(\
			caps_str) )
		self.restart_sound_device()
		
	
	def start_sound_device(self):
		self.fakesink.set_property("signal-handoffs",True)		
		self.pipeline.set_state(gst.STATE_PLAYING)
		##############Alsamixer settings at Activity start################		
		#Playback settings		
		os.system("amixer set 'Mic' mute 0%")
		os.system("amixer set 'Mic Boost (+20dB)' mute")
		os.system("amixer set 'DC Mode Enable' mute")
		os.system("amixer set 'V_REFOUT Enable' unmute")
		os.system("amixer set 'PCM' unmute 90%")
		#Capture settings
		os.system("amixer set 'Mic' 0%, 0% mute captur")
		os.system("amixer set 'Capture' 50%, 50% unmute captur")
		##################################################################	
		
	




