#! /usr/bin/python
import pygst
pygst.require("0.10")
import pygtk
import gtk
import cairo
import gobject
from time import *
from struct import *
import pango
import os
import audioop
import math
from gtk import gdk
from Numeric import *
from FFT import *

from gettext import gettext as _

import config  	#This has all the globals


class DrawWaveform(gtk.DrawingArea):
	def __init__(self, grabber):
		
		gtk.DrawingArea.__init__(self)
		self.connect("expose_event", self.expose)
		grabber.connect("new-buffer", self._new_buffer)

		self.buffers = []
		self.str_buffer=''
		self.buffers_temp=[]
		self.integer_buffer=[]	
		self.peaks = []
		self.main_buffers = []
		self.fftx = []
	
		self.rms=''
		self.avg=''
		self.pp=''	
		self.count=0
	
		self.param1= config.WINDOW_H/65536.0
		self.param2= config.WINDOW_H/2.0	
		self.y_mag = 3.0
		self.g = 1  #Gain (not in dB) introduced by Capture Gain and Mic Boost    
		self.freq_range = 70
		self.draw_interval = 10
		self.num_of_points = 115
		self.details_iter = 50
		self.c = 1180
		self.m = 0.0238
		self.k = 0.0238
		self.c2 = 139240	#c squared
		self.t_x = (int)(config.TEXT_X_M*config.WINDOW_W)
		self.t_y = (int)(config.TEXT_Y_M*config.WINDOW_H)
		self.rms = 0
		self.avg = 0
		self.Rv = 0
		self.y_mag_bias_multiplier = 1	#constant to multiply with self.param2 while scaling values 
		self.log_param1 = ""
		self.log_param2 = ""
		self.log_param3 = ""
		self.log_param4 = ""
		self.log_param5 = ""

		self.details_show = False
		self.logging_status = False
		self.f = None
		self.stop = False
		self.fft_show = False
		self.side_toolbar_copy = None

		self.scaleX = str( 1.04167/self.draw_interval ) + " ms"
		self.scaleY = ""

		self._line_gc = None
		self._back_surf = None		
		self.pango_context = self.create_pango_context()
		#self.font_desc = pango.FontDescription('Serif 6')
		
		
	def _new_buffer(self, obj, buf, status, f):
		self.str_buffer = buf
		self.integer_buffer = list(unpack( str(int(len(buf))/2)+'h' , buf))		
		if(len(self.main_buffers)>116):
			del self.main_buffers[0:(len(self.main_buffers)-116)]
		self.main_buffers += self.integer_buffer
		self.logging_status = status
		self.f = f
		return True


	def _init_background(self):
		if self._back_surf:
			return

		colmap = self.get_colormap()
		clr = colmap.alloc_color(0, 65535, 0, False, False)
		self._line_gc = self.window.new_gc(foreground = clr)
		self._line_gc.set_line_attributes(4, gdk.LINE_SOLID,\
			gdk.CAP_ROUND, gdk.JOIN_BEVEL)   

		self._back_surf = gdk.Pixmap(self.window, int(config.WINDOW_W), \
			int(config.WINDOW_H))
		cr = self._back_surf.cairo_create()
		
				
		#background
		cr.set_source_rgb(0, 0, 0)
		cr.rectangle(0, 0, config.WINDOW_W, config.WINDOW_H)
		cr.fill()

		#grid
		cr.set_line_width(0.4)
		cr.set_source_rgb(0.2, 0.2, 0.2)

		x = 0
		y = 0
		
		for j in range(1, 24):
			cr.move_to(x, y)
			cr.rel_line_to(0, config.WINDOW_H)
			x = x + 50

		cr.set_line_width(1.0)
		x = 0
		y = 0

		for j in range(1, 17):
			cr.move_to(x, y)
			cr.rel_line_to(config.WINDOW_W, 0)
			y = y + 50

		cr.stroke()	

			
	#######################################################################
	# This function is the "expose" event handler and does all the drawing
	#######################################################################
	def expose(self, widget, event):
		
		###############REAL TIME DRAWING##########################################
		if(self.logging_status==False):
			if(self.stop==False):		

				self.draw_interval = 10			
				if(self.fft_show==False):				
					
					self.y_mag_bias_multiplier = 1					
					
					
					#low freq range, 4khz sampling
					if(self.freq_range==30):
						self.spacing = 1
						self.num_of_points = 115
						self.freq_range_ch = 'l'
						self.scaleX = str( 12.5/self.draw_interval ) + " ms"
							
					#med freq range, 16khz sampling
					if(self.freq_range==50):
						self.spacing = 1
						self.num_of_points = 115
						self.freq_range_ch = 'm'
						self.scaleX = str( 3.125/self.draw_interval ) + " ms"
							
					#high freq range, 48khz sampling
					if(self.freq_range==70):
						self.spacing = 1
						self.num_of_points = 115
						self.freq_range_ch = 'h'
						self.scaleX = str( 1.04167/self.draw_interval ) + " ms"
					
					
					
					if(len(self.main_buffers)>=self.num_of_points):
						del self.main_buffers[0:len(self.main_buffers)-(self.num_of_points+1)]
						self.buffers=[]
						i=0
						while i<self.num_of_points:
							self.buffers.append(self.main_buffers[i])						
							i+=self.spacing
				
					
				
				else:
					###############fft################		
					Fs = 48000
					nfft = 65536
					self.integer_buffer = self.integer_buffer[0:256]
					self.fftx = fft(self.integer_buffer, 256,-1)
					
					self.fftx = self.fftx[0:self.freq_range*2]
					self.draw_interval = config.WINDOW_W/(self.freq_range*2)
					
					NumUniquePts = ceil((nfft+1)/2)
					self.buffers = abs(self.fftx)*0.02
					self.y_mag_bias_multiplier=0.1
					if(self.freq_range == 30):
						self.scaleX = "41.67 Hz"	
					elif(self.freq_range == 50):
						self.scaleX = "281.25 Hz"
					elif(self.freq_range == 70):
						self.scaleX = "1125 Hz"
					self.scaleY = _('Spectrum value')
					##################################
								

				
		###########################drawing from a file#################################		
		else:
			self.draw_interval = 10			
			if(self.f.closed==False):			
				self.buffers = []			
				line = self.f.readline()
				if(line=="measure.activity.log.start\n"):	

					line = self.f.readline()
					if(line=="second\n" or line=="minute\n" \
						or line=="hour\n" or \
						line=="snapshot\n"):
						self.log_param1 = line
						self.log_param2 = self.f.readline()	
						self.log_param3 = self.f.readline()	
						self.log_param4 = self.f.readline()	
						self.log_param5 = self.f.readline()	

						for line in self.f.readlines():
							if(line != "stop"):						
								self.buffers.append(float(line))

						#############Setting various settings, scale################
						self.side_toolbar_copy.yscrollbar.set_value(float(self.log_param3))
						#####
						if(self.log_param5 == "l\n"):
							log_param5_temp = 30
						if(self.log_param5 == "m\n"):
							log_param5_temp = 50
						if(self.log_param5 == "h\n"):
							log_param5_temp = 70
						self.electrical_ui_copy._freq_range.set_value(log_param5_temp)
						#####
						if(self.log_param1 == "second\n"):
							self.scaleX = "5 seconds"
						elif(self.log_param1 == "minute\n"):
							self.scaleX = "5 minutes"
						elif(self.log_param1 == "hour\n"):
							self.scaleX = "5 hours"
						elif(self.log_param1 == "snapshot\n"):
							pass	#Use scale setting resulting from self.log_param5
						#####
						if(self.log_param2 == "freq\n"):
							self.y_mag_bias_multiplier = 0.1
							if(self.log_param5 == "l\n"):
								self.scaleX = "41.67 Hz"	
							elif(self.log_param5 == "m\n"):
								self.scaleX = "281.25 Hz"
							elif(self.log_param5 == "h\n"):
								self.scaleX = "1125 Hz"
							self.scaleY = _('Spectrum value')
								
						else:
							self.y_mag_bias_multiplier = 1	
						############################################################							
								
				self.f.close()
				
				
		################################################################################
		
					
		if(len(self.buffers) == 0):
			return 
			
		
		###############Scaling the values################		
		val=[]
		for i in self.buffers:
			temp_val_float = float(self.param1*i*self.y_mag) + self.y_mag_bias_multiplier * self.param2
			
			if(temp_val_float>=config.WINDOW_H):
				temp_val_float= config.WINDOW_H-25
			if(temp_val_float<=0):
				temp_val_float= 25
			val.append( temp_val_float  )
		
		self.peaks=val
		#################################################
			
		#Draw the background
		#We could probably make this faster with another pixmap.
		self._init_background()
		self.window.draw_drawable(self.get_style().bg_gc[0], self._back_surf, 0, 0,\
			0, 0, config.WINDOW_W, config.WINDOW_H)

		
		#Draw the waveform
		count = 5
		#There is probably a way to cache these lines between draws. (?)
		lines = []
		for peak in self.peaks:
			lines.append((count, config.WINDOW_H - peak))
			count = count + self.draw_interval
		self.window.draw_lines(self._line_gc, lines)


		
		###########Text Display#####################
		if (self.details_show == True):		
			if(self.count%self.details_iter==0):
				self.k = (self.m/self.g)
				self.rms = audioop.rms(self.str_buffer, 2)
				self.avg = audioop.avg(self.str_buffer, 2) 
				self.Av = self.m*self.avg + self.c
				self.Rv = math.sqrt ( math.pow(self.k*self.rms, 2) + \
					self.c2 + 2*self.k*self.avg )
				
			
			if(self.fft_show == False and self.logging_status == False):
				self.scaleY = str((73.75/self.g)*self.y_mag) + \
					str(self.c) + " mV"			
			self.count+=1
			if(self.count==65536):
				self.count=0

			layout = pango.Layout(self.pango_context)
			#layout.set_font_description(self.font_desc)	

			
			layout.set_text("\n" + _('RMS   : ') + str(self.Rv) +" mV" +"\n" + _('AVG   : ')\
				+ str(self.Av) + " mV"  + "\n\n" + _('Scale:') + \
				"\n" + _('X Axis: ') + self.scaleX + "\n"+ _('Y Axis : ') \
				+ self.scaleY)
				
			self.window.draw_layout(self.get_style().white_gc, self.t_x,\
				self.t_y, layout)
		############################################		
		
		return True


	def set_side_toolbar_reference(self, side_toolbar):
		self.side_toolbar_copy = side_toolbar


	def set_electrical_ui_reference(self, electrical_ui):
		self.electrical_ui_copy = electrical_ui
